/**
 * @license
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function(){"use strict";var t=function(){function t(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||false;n.configurable=true;if("value"in n)n.writable=true;Object.defineProperty(t,n.key,n)}}return function(e,r,n){if(r)t(e.prototype,r);if(n)t(e,n);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var r=function r(t){return"("+(t?t.replace(/(^<|>$)/g,""):"[a-zA-Z0-9-_.~]+")+")"};var n=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(r(t[2]))}},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(t){return new RegExp(";"+t[1]+"="+r(t[2]))}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function a(t){return new RegExp(t[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function a(t){return new RegExp(t[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function a(t){return new RegExp(t[0])}}];var i=function i(t){var e=arguments[1]===undefined?[]:arguments[1];var r=n.some(function(r){var n=t.match(r.pattern);if(!n)return false;e.push({type:r.name,match:n[0],val:n.slice(1,2),otherVal:n.slice(2),regex:r.regex instanceof Function?r.regex(n):r.regex});if(n[0].length<t.length)e=i(t.substr(n[0].length),e);return true});if(!r){throw new Error("Could not parse path.")}return e};var s=function(){function n(t){e(this,n);if(!t)throw new Error("Please supply a path");this.path=t;this.tokens=i(t);this.hasUrlParams=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(t){return/splat$/.test(t.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(t){return/matrix$/.test(t.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(t){return t.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(t){return/^url-parameter/.test(t.type)}).map(function(t){return t.val.slice(0,1)}).reduce(function(t,e){return t.concat(e)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(t){return t.type==="query-parameter"}).map(function(t){return t.val}).reduce(function(t,e){return t.concat(e)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(t){return t.regex!==undefined}).map(function(t){return t.regex.source}).join("")}t(n,[{key:"_urlMatch",value:function a(t,e){var r=this;var n=t.match(e);if(!n)return null;else if(!this.urlParams.length)return{};return n.slice(1,this.urlParams.length+1).reduce(function(t,e,n){t[r.urlParams[n]]=e;return t},{})}},{key:"match",value:function s(t){var e=this;var r=this._urlMatch(t,new RegExp("^"+this.source+(this.hasQueryParams?"?.*$":"$")));if(!r||!this.hasQueryParams)return r;var n=t.split("?")[1].split("&").map(function(t){return t.split("=")}).reduce(function(t,e){t[e[0]]=e[1];return t},{});if(Object.keys(n).every(function(t){return Object.keys(e.queryParams).indexOf(t)!==1})&&Object.keys(n).length===this.queryParams.length){Object.keys(n).forEach(function(t){return r[t]=n[t]});return r}return null}},{key:"partialMatch",value:function u(t){return this._urlMatch(t,new RegExp("^"+this.source))}},{key:"build",value:function o(){var t=arguments[0]===undefined?{}:arguments[0];var e=arguments[1]===undefined?false:arguments[1];if(!this.params.every(function(e){return t[e]!==undefined}))throw new Error("Missing parameters");if(!e){var n=this.tokens.filter(function(t){return/^url-parameter/.test(t.type)&&!/-splat$/.test(t.type)}).every(function(e){return new RegExp("^"+r(e.otherVal[0])+"$").test(t[e.val])});if(!n)throw new Error("Some parameters are of invalid format")}var a=this.tokens.filter(function(t){return t.type!=="query-parameter"}).map(function(e){if(e.type==="url-parameter-matrix")return";"+e.val[0]+"="+t[e.val[0]];return/^url-parameter/.test(e.type)?t[e.val[0]]:e.match}).join("");var i=this.queryParams.map(function(e){return e+"="+t[e]}).join("&");return a+(i?"?"+i:"")}}]);return n}();var u=function(){function r(){var t=arguments[0]===undefined?"":arguments[0];var n=arguments[1]===undefined?"":arguments[1];var a=arguments[2]===undefined?[]:arguments[2];e(this,r);this.name=t;this.path=n;this.parser=n?new s(n):null;this.children=[];this.add(a);return this}t(r,[{key:"add",value:function n(t){var e=this;if(t instanceof Array){t.forEach(function(t){return e.add(t)});return}if(!(t instanceof r)&&!(t instanceof Object)){throw new Error("Route constructor expects routes to be an Object or an instance of Route.")}if(t instanceof Object){if(!t.name||!t.path){throw new Error("Route constructor expects routes to have an name and a path defined.")}t=new r(t.name,t.path,t.children)}if(this.children.map(function(t){return t.name}).indexOf(t.name)!==-1){throw new Error('Alias "'+t.name+'" is already defined in route node')}if(this.children.map(function(t){return t.path}).indexOf(t.path)!==-1){throw new Error('Path "'+t.path+'" is already defined in route node')}var n=t.name.split(".");if(n.length===1){this.children.push(t);this.children.sort(function(t,e){if(!t.parser.hasSpatParam&&e.parser.hasSpatParam)return-1;if(!e.parser.hasSpatParam&&t.parser.hasSpatParam)return 1;if(!t.parser.hasUrlParams&&e.parser.hasUrlParams)return-1;if(!e.parser.hasUrlParams&&t.parser.hasUrlParams)return 1;return 0})}else{var a=this.getSegmentsByName(n.slice(0,-1).join("."));if(a){a[a.length-1].add(new r(n[n.length-1],t.path,t.children))}else{throw new Error("Could not add route named '"+t.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(t,e){this.add(new r(t,e));return this}},{key:"getSegmentsByName",value:function i(t){var e=function e(t,e){var r=e.filter(function(e){return e.name===t});return r.length?r[0]:undefined};var r=[];var n=t.split(".");var a=this.children;var i=n.every(function(t){var n=e(t,a);if(n){a=n.children;r.push(n);return true}return false});return i?r:null}},{key:"getSegmentsMatchingPath",value:function u(t){var e=function e(t,r,n){var a=function(a){var i=t[a];var s=i.parser.partialMatch(r);if(s){n.push(i);Object.keys(s).forEach(function(t){return n.params[t]=s[t]});var u=r.replace(i.parser.build(s),"");if(!u.length){return{v:n}}if(!i.children.length){return{v:null}}return{v:e(i.children,u,n)}}};for(var i in t){var s=a(i);if(typeof s==="object")return s.v}return null};var r=this.parser?[this]:this.children;var n=[];n.params={};return e(r,t,n)}},{key:"getPathFromSegments",value:function o(t){return t?t.map(function(t){return t.path}).join(""):null}},{key:"getPath",value:function h(t){return this.getPathFromSegments(this.getSegmentsByName(t))}},{key:"buildPathFromSegments",value:function l(t){var e=arguments[1]===undefined?{}:arguments[1];return t?t.map(function(t){return t.parser.build(e)}).join(""):null}},{key:"buildPath",value:function c(t){var e=arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(t),e)}},{key:"getMatchPathFromSegments",value:function f(t){if(!t)return null;var e=t.map(function(t){return t.name}).join(".");var r=t.params;return{name:e,params:r}}},{key:"matchPath",value:function m(t){return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(t))}}]);return r}();var t=function(){function t(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||false;n.configurable=true;if("value"in n)n.writable=true;Object.defineProperty(t,n.key,n)}}return function(e,r,n){if(r)t(e.prototype,r);if(n)t(e,n);return e}}();function e(t,e){if(!(t instanceof e)){throw new TypeError("Cannot call a class as a function")}}var o=function o(t){return t.split(".").reduce(function(t,e){t.push(t.length?t[t.length-1]+"."+e:e);return t},[])};var h=function h(t,e,r){return{name:t,params:e,path:r}};var l=function(){function r(t){var n=this;var a=arguments[1]===undefined?{}:arguments[1];e(this,r);this.started=false;this.callbacks={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=t instanceof u?t:new u("","",t);this.activeComponents={};this.options={useHash:false,hashPrefix:""};Object.keys(a).forEach(function(t){return n.options[t]=a[t]});this.base=window.location.pathname.replace(/^\/$/,"");return this}t(r,[{key:"setOption",value:function n(t,e){this.options[t]=e;return this}},{key:"add",value:function a(t){this.rootNode.add(t);return this}},{key:"addNode",value:function i(t,e){this.rootNode.addNode(t,e);return this}},{key:"onPopState",value:function s(t){var e=t.state||this.matchPath(this.getLocation());if(!e)return;if(this.lastKnownState&&this.areStatesEqual(e,this.lastKnownState))return;var r=this._transition(e,this.lastKnownState);if(!r){var n=this.buildUrl(this.lastKnownState.name,this.lastKnownState.params);window.history.pushState(this.lastKnownState,"",n)}}},{key:"start",value:function l(){if(this.started)return this;this.started=true;var t=this.getLocation();var e=this.matchPath(t);if(e){this.lastKnownState=e;window.history.replaceState(this.lastKnownState,"",this.buildUrl(e.name,e.params))}else if(this.options.defaultRoute){this.navigate(this.options.defaultRoute,this.options.defaultParams,{replace:true})}window.addEventListener("popstate",this.onPopState.bind(this));return this}},{key:"stop",value:function c(){if(!this.started)return this;this.started=false;window.removeEventListener("popstate",this.onPopState.bind(this));return this}},{key:"getState",value:function f(){return this.lastKnownState}},{key:"isActive",value:function m(t){var e=arguments[1]===undefined?{}:arguments[1];var r=arguments[2]===undefined?false:arguments[2];var n=this.getState();if(!n)return false;if(r||n.name===t){return this.areStatesEqual(h(t,e),n)}else{return this.areStatesDescendants(h(t,e),n)}}},{key:"areStatesEqual",value:function p(t,e){return t.name===e.name&&Object.keys(t.params).length===Object.keys(e.params).length&&Object.keys(t.params).every(function(r){return t.params[r]===e.params[r]})}},{key:"areStatesDescendants",value:function d(t,e){var r=new RegExp("^"+t.name+"\\.(.*)$");if(!r.test(e.name))return false;return Object.keys(t.params).every(function(r){return t.params[r]===e.params[r]})}},{key:"_invokeListeners",value:function v(t,e,r){if(!this.callbacks[t])return;this.callbacks[t].forEach(function(t){return t(e,r)})}},{key:"_addListener",value:function g(t,e){var r=t.replace(/^(\*|\^|=)/,"");if(r){var n=this.rootNode.getSegmentsByName(r);if(!n)console.warn("No route found for "+r+", listener might never be called!")}if(!this.callbacks[t])this.callbacks[t]=[];this.callbacks[t].push(e);return this}},{key:"_removeListener",value:function y(t,e){if(this.callbacks[t])this.callbacks[t]=this.callbacks[t].filter(function(t){return t!==e});return this}},{key:"addListener",value:function w(t){return this._addListener("*",t)}},{key:"removeListener",value:function k(t){return this._removeListener("*",t)}},{key:"addNodeListener",value:function b(t,e){return this._addListener("^"+t,e)}},{key:"removeNodeListener",value:function P(t,e){return this._removeListener("^"+t,e)}},{key:"addRouteListener",value:function S(t,e){return this._addListener("="+t,e)}},{key:"removeRouteListener",value:function x(t,e){return this._removeListener("="+t,e)}},{key:"registerComponent",value:function E(t,e){if(this.activeComponents[t])console.warn("A component was alread registered for route node "+t+".");this.activeComponents[t]=e;return this}},{key:"deregisterComponent",value:function _(t){delete this.activeComponents[t]}},{key:"getLocation",value:function L(){return this.options.useHash?window.location.hash.replace(new RegExp("^#"+this.options.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+this.base),"")}},{key:"buildUrl",value:function j(t,e){return(this.options.useHash?window.location.pathname+"#"+this.options.hashPrefix:this.base)+this.rootNode.buildPath(t,e)}},{key:"buildPath",value:function R(t,e){return this.rootNode.buildPath(t,e)}},{key:"matchPath",value:function A(t){var e=this.rootNode.matchPath(t);return e?h(e.name,e.params,t):null}},{key:"_transition",value:function N(t,e){var r=this;if(!e){this.lastKnownState=t;this._invokeListeners("*",t,e);return true}var n=undefined;var a=false;var i=o(e.name);var s=o(t.name);var u=Math.min(i.length,s.length);for(n=0;n<u;n+=1){if(i[n]!==s[n])break}a=i.slice(n).reverse().map(function(t){return r.activeComponents[t]}).filter(function(t){return t&&t.canDeactivate}).some(function(r){return!r.canDeactivate(t,e)});if(!a){this.lastKnownState=t;this._invokeListeners("^"+(n>0?i[n-1]:""),t,e);this._invokeListeners("="+t.name,t,e);this._invokeListeners("*",t,e)}return!a}},{key:"navigate",value:function O(t){var e=arguments[1]===undefined?{}:arguments[1];var r=arguments[2]===undefined?{}:arguments[2];if(!this.started)return;var n=this.buildPath(t,e);var a=this.buildUrl(t,e);if(!n)throw new Error('Could not find route "'+t+'"');this.lastStateAttempt=h(t,e,n);var i=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt):false;if(i&&!r.reload)return;var s=this._transition(this.lastStateAttempt,this.lastKnownState);if(s&&!i){window.history[r.replace?"replaceState":"pushState"](this.lastStateAttempt,"",a)}return s}}]);return r}();window.RouteNode=u;window.Router5=l})();